/*
 *    MotionServer.h
 *
 *    Copyright (C) 2008-2011 Yvan Roch <yvan.roch@gmail.com>
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MOTIONSERVER_H_
#define MOTIONSERVER_H_

#define MOTION_SERVER_TCP_PORT 1972

#define SOCKET_ERROR        -1
#define BUFFER_SIZE         100
#define MOTION_SERVER_SIGNATURE "MOTION SERVER OK"
#define MOTION_SERVER_ERROR "ERROR"
#define QUEUE_SIZE          0
#define NBR_OF_MANAGED_SERVOS 24
#define MAX_SERVO_VALUE 4096
#define RMMOD "/sbin/rmmod"
#define INSMOD "/sbin/insmod"
#define SERVO_DRIVER_SYSFS_BASE "/sys/class/servo/"
//#define SERVO_DRIVER_SYSFS_BASE "/sys/class/servo_contoller/servo_contoller0/"
#define SERVO_DRIVER_SERVO_FILE "servo"
#define SERVO_DRIVER_SERVO_POSITION_FILE "desired_position"
#define SERVO_DRIVER_SERVO_ENABLE_FILE "enable"
#define SERVO_DRIVER_SERVO_OFFSET_FILE "offset"
#define SERVO_DRIVER_SERVO_MIN_FILE "lower_boundary"
#define SERVO_DRIVER_SERVO_MAX_FILE "upper_boundary"

/*
 * Variables
 */
int hServerSocket;  /* handle to main server socket */
int hSocket;  /* handle to socket to client socket*/

/*
 * Functions
 */
void prinfDefaultConfig(void);
void setServoPosition(int,int);
void setServoEnable(int,int);
void setServoOffset(int,int);
void setServoMin(int,int);
void setServoMax(int,int);
void getServoPosition(int);
void getServoEnable(int);
void getServoOffset(int);
void getServoMin(int);
void getServoMax(int);
void prinfDefaultConfig(void);
int writeDefaultConfig(char*);
void cleaning(int);

#endif /* MOTIONSERVER_H_ */
