%{
#include<stdio.h>
#include "MotionServer.h"
extern commandlineno;
extern commandtext;
void commanderror (const char *);
%}
%union {
	char token_string[128];
	int num;
}
%token <num> NUMBER
%token <token_string> FILE_PATH
%token SET_POSITION SET_ENABLE SET_OFFSET SET_MIN SET_MAX
%token GET_POSITION GET_ENABLE GET_OFFSET GET_MIN GET_MAX
%token WRITE_CONFIG_FILE SLEEP
%token COMMA LPAR RPAR DOUBLE_QUOTES EOL
%%
COMMAND: SET_POSITION LPAR NUMBER COMMA NUMBER RPAR {setServoPosition($3,$5);}
		|SET_ENABLE LPAR NUMBER COMMA NUMBER RPAR {setServoEnable($3,$5);}
		|SET_OFFSET LPAR NUMBER COMMA NUMBER RPAR {setServoOffset($3,$5);}
		|SET_MIN LPAR NUMBER COMMA NUMBER RPAR {setServoMin($3,$5);}
		|SET_MAX LPAR NUMBER COMMA NUMBER RPAR {setServoMax($3,$5);}
		|GET_POSITION LPAR NUMBER RPAR {getServoPosition($3);}
		|GET_ENABLE LPAR NUMBER RPAR {getServoEnable($3);}
		|GET_OFFSET LPAR NUMBER RPAR {getServoOffset($3);}
		|GET_MIN LPAR NUMBER RPAR {getServoMin($3);}
		|GET_MAX LPAR NUMBER RPAR {getServoMax($3);}
		|WRITE_CONFIG_FILE DOUBLE_QUOTES FILE_PATH DOUBLE_QUOTES {writeDefaultConfig($3);}
		|SLEEP LPAR NUMBER RPAR {sleep($3);}
		|COMMAND EOL
		|EOL
		;
%%
void commanderror (const char *msg){
	printf("%d: %s at '%s'\n",commandlineno,msg,commandtext);
}
