%{
#include<stdio.h>
#include <string.h>
#include "MotionServer.h"

extern rcfilelineno;
extern rcfiletext;
void rcfileerror (const char *);

static int value1;
static int value2;
static char msgBuffer[1024];
int servoEnableBuffer[NBR_OF_MANAGED_SERVOS];
int servoPositionBuffer[NBR_OF_MANAGED_SERVOS];
int servoOffsetBuffer[NBR_OF_MANAGED_SERVOS];
int servoMinBuffer[NBR_OF_MANAGED_SERVOS];
int servoMaxBuffer[NBR_OF_MANAGED_SERVOS];
static int *servoDefaultParam;
char moduleFilePathBuffer[1024];
int moduleLoadBuffer;

%}
%union {
	char token_string[128];
	int num;
}
%token <num> INTEGER
%token <token_string> ServoModuleFilePath
%token <token_string> LoadServoModule
%token <token_string> ServoPosition
%token <token_string> ServoOffset
%token <token_string> ServoMin
%token <token_string> ServoMax
%token <token_string> ServoEnable
%token <token_string> Default
%token <token_string> Module
%token <token_string> ModuleFilePath
%token <token_string> ModuleLoad
%token <token_string> FILE_PATH
%token COMMA LPAR RPAR LBR RBR EQ EOL

%type <token_string> SERVO_DEFAULT_OPERATOR

%%
CONFIG_FILE: GROUP_OF_SECTIONS;

GROUP_OF_SECTIONS: SECTION
		| GROUP_OF_SECTIONS SECTION
		;

SECTION: SECTION_HEADER GROUP_OF_LINES;

GROUP_OF_LINES: LINE
		| GROUP_OF_LINES LINE
		;

SECTION_HEADER: LBR SECTION_NAME RBR EOL;

SECTION_NAME: Default
		|Module
		;

LINE: SERVO_DEFAULT_OPERATOR SERVO_DEFAULT_OPERAND EOL {
	servoDefaultParam[value1]=value2;
}
		| MODULE_LINE
		| EOL
		;

SERVO_DEFAULT_OPERATOR: ServoPosition { servoDefaultParam=servoPositionBuffer; }
		|ServoOffset { servoDefaultParam=servoOffsetBuffer; }
		|ServoMin { servoDefaultParam=servoMinBuffer; }
		|ServoMax { servoDefaultParam=servoMaxBuffer; }
		|ServoEnable { servoDefaultParam=servoEnableBuffer; }
		;

SERVO_DEFAULT_OPERAND: INTEGER INTEGER {
	value1=$1;
	if (value1 >= NBR_OF_MANAGED_SERVOS){
		sprintf(msgBuffer,"NBR_OF_MANAGED_SERVOS : %d, %d is out of range!!!",NBR_OF_MANAGED_SERVOS,value1);
		rcfileerror(msgBuffer);
		YYABORT;
	}
	value2=$2;
	if (value2 >= MAX_SERVO_VALUE){
		sprintf(msgBuffer,"MAX_SERVO_VALUE : %d, %d is out of range!!!",MAX_SERVO_VALUE,value2);
		rcfileerror(msgBuffer);
		YYABORT;
	}
}

MODULE_LINE: ModuleFilePath FILE_PATH {
	strcpy(moduleFilePathBuffer,$2);
}
		|ModuleLoad INTEGER {
	if ($2 != 0 && $2 != 1){
		sprintf(msgBuffer,"ModuleLoad : %d Boolean parameter, only 0 or 1 is accepted!!!",$2);
		rcfileerror(msgBuffer);
		YYABORT;
	}
	moduleLoadBuffer=$2;
}
		;

%%
/* Inclure la fonction yyerror permet d'eviter d'inclure la bibliotheque yacc liby.so*/
void rcfileerror (const char *msg)
{
	printf("Configuration file error: line %d: %s at '%s'\n",rcfilelineno,msg,rcfiletext);
}


