/*
 *    servogui.cpp
 *
 *    Copyright (C) 2008-2011 Yvan Roch <yvan.roch@gmail.com>
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "servogui.h"
#include <stdio.h>

ServoGui::ServoGui(QWidget *parent)
    : QDialog(parent)
{
	ui.setupUi(this);
}
ServoGui::ServoGui(QApplication *parent)
{
	ui.setupUi(this);
	this->parent=parent;
	/* Initialization of widget arrays */
	verticalSliders[0]=this->ui.verticalSlider_0;
	verticalSliders[1]=this->ui.verticalSlider_1;
	verticalSliders[2]=this->ui.verticalSlider_2;
	verticalSliders[3]=this->ui.verticalSlider_3;
	verticalSliders[4]=this->ui.verticalSlider_4;
	verticalSliders[5]=this->ui.verticalSlider_5;
	verticalSliders[6]=this->ui.verticalSlider_6;
	verticalSliders[7]=this->ui.verticalSlider_7;
	verticalSliders[8]=this->ui.verticalSlider_8;
	verticalSliders[9]=this->ui.verticalSlider_9;
	verticalSliders[10]=this->ui.verticalSlider_10;
	verticalSliders[11]=this->ui.verticalSlider_11;
	verticalSliders[12]=this->ui.verticalSlider_12;
	verticalSliders[13]=this->ui.verticalSlider_13;
	verticalSliders[14]=this->ui.verticalSlider_14;
	verticalSliders[15]=this->ui.verticalSlider_15;
	verticalSliders[16]=this->ui.verticalSlider_16;
	verticalSliders[17]=this->ui.verticalSlider_17;
	verticalSliders[18]=this->ui.verticalSlider_18;
	verticalSliders[19]=this->ui.verticalSlider_19;
	verticalSliders[20]=this->ui.verticalSlider_20;
	verticalSliders[21]=this->ui.verticalSlider_21;
	verticalSliders[22]=this->ui.verticalSlider_22;
	verticalSliders[23]=this->ui.verticalSlider_23;

	offsetSpinboxes[0]=this->ui.off_0;
	offsetSpinboxes[1]=this->ui.off_1;
	offsetSpinboxes[2]=this->ui.off_2;
	offsetSpinboxes[3]=this->ui.off_3;
	offsetSpinboxes[4]=this->ui.off_4;
	offsetSpinboxes[5]=this->ui.off_5;
	offsetSpinboxes[6]=this->ui.off_6;
	offsetSpinboxes[7]=this->ui.off_7;
	offsetSpinboxes[8]=this->ui.off_8;
	offsetSpinboxes[9]=this->ui.off_9;
	offsetSpinboxes[10]=this->ui.off_10;
	offsetSpinboxes[11]=this->ui.off_11;
	offsetSpinboxes[12]=this->ui.off_12;
	offsetSpinboxes[13]=this->ui.off_13;
	offsetSpinboxes[14]=this->ui.off_14;
	offsetSpinboxes[15]=this->ui.off_15;
	offsetSpinboxes[16]=this->ui.off_16;
	offsetSpinboxes[17]=this->ui.off_17;
	offsetSpinboxes[18]=this->ui.off_18;
	offsetSpinboxes[19]=this->ui.off_19;
	offsetSpinboxes[20]=this->ui.off_20;
	offsetSpinboxes[21]=this->ui.off_21;
	offsetSpinboxes[22]=this->ui.off_22;
	offsetSpinboxes[23]=this->ui.off_23;

	minSpinboxes[0]=this->ui.min_0;
	minSpinboxes[1]=this->ui.min_1;
	minSpinboxes[2]=this->ui.min_2;
	minSpinboxes[3]=this->ui.min_3;
	minSpinboxes[4]=this->ui.min_4;
	minSpinboxes[5]=this->ui.min_5;
	minSpinboxes[6]=this->ui.min_6;
	minSpinboxes[7]=this->ui.min_7;
	minSpinboxes[8]=this->ui.min_8;
	minSpinboxes[9]=this->ui.min_9;
	minSpinboxes[10]=this->ui.min_10;
	minSpinboxes[11]=this->ui.min_11;
	minSpinboxes[12]=this->ui.min_12;
	minSpinboxes[13]=this->ui.min_13;
	minSpinboxes[14]=this->ui.min_14;
	minSpinboxes[15]=this->ui.min_15;
	minSpinboxes[16]=this->ui.min_16;
	minSpinboxes[17]=this->ui.min_17;
	minSpinboxes[18]=this->ui.min_18;
	minSpinboxes[19]=this->ui.min_19;
	minSpinboxes[20]=this->ui.min_20;
	minSpinboxes[21]=this->ui.min_21;
	minSpinboxes[22]=this->ui.min_22;
	minSpinboxes[23]=this->ui.min_23;

	maxSpinboxes[0]=this->ui.max_0;
	maxSpinboxes[1]=this->ui.max_1;
	maxSpinboxes[2]=this->ui.max_2;
	maxSpinboxes[3]=this->ui.max_3;
	maxSpinboxes[4]=this->ui.max_4;
	maxSpinboxes[5]=this->ui.max_5;
	maxSpinboxes[6]=this->ui.max_6;
	maxSpinboxes[7]=this->ui.max_7;
	maxSpinboxes[8]=this->ui.max_8;
	maxSpinboxes[9]=this->ui.max_9;
	maxSpinboxes[10]=this->ui.max_10;
	maxSpinboxes[11]=this->ui.max_11;
	maxSpinboxes[12]=this->ui.max_12;
	maxSpinboxes[13]=this->ui.max_13;
	maxSpinboxes[14]=this->ui.max_14;
	maxSpinboxes[15]=this->ui.max_15;
	maxSpinboxes[16]=this->ui.max_16;
	maxSpinboxes[17]=this->ui.max_17;
	maxSpinboxes[18]=this->ui.max_18;
	maxSpinboxes[19]=this->ui.max_19;
	maxSpinboxes[20]=this->ui.max_20;
	maxSpinboxes[21]=this->ui.max_21;
	maxSpinboxes[22]=this->ui.max_22;
	maxSpinboxes[23]=this->ui.max_23;

	enableCheckboxes[0]=this->ui.checkBox_0;
	enableCheckboxes[1]=this->ui.checkBox_1;
	enableCheckboxes[2]=this->ui.checkBox_2;
	enableCheckboxes[3]=this->ui.checkBox_3;
	enableCheckboxes[4]=this->ui.checkBox_4;
	enableCheckboxes[5]=this->ui.checkBox_5;
	enableCheckboxes[6]=this->ui.checkBox_6;
	enableCheckboxes[7]=this->ui.checkBox_7;
	enableCheckboxes[8]=this->ui.checkBox_8;
	enableCheckboxes[9]=this->ui.checkBox_9;
	enableCheckboxes[10]=this->ui.checkBox_10;
	enableCheckboxes[11]=this->ui.checkBox_11;
	enableCheckboxes[12]=this->ui.checkBox_12;
	enableCheckboxes[13]=this->ui.checkBox_13;
	enableCheckboxes[14]=this->ui.checkBox_14;
	enableCheckboxes[15]=this->ui.checkBox_15;
	enableCheckboxes[16]=this->ui.checkBox_16;
	enableCheckboxes[17]=this->ui.checkBox_17;
	enableCheckboxes[18]=this->ui.checkBox_18;
	enableCheckboxes[19]=this->ui.checkBox_19;
	enableCheckboxes[20]=this->ui.checkBox_20;
	enableCheckboxes[21]=this->ui.checkBox_21;
	enableCheckboxes[22]=this->ui.checkBox_22;
	enableCheckboxes[23]=this->ui.checkBox_23;

	socket = new QTcpSocket(this);
	state = MOTION_CLIENT_STATE_NOT_CONNECTED;
	printf("state: MOTION_CLIENT_STATE_NOT_CONNECTED\n");
}
ServoGui::~ServoGui()
{

}
void ServoGui::on_pushButtonSendBatchFile_clicked(void){
	QFile batchFile("");
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	if (ui.lineEditBatchFile->text().isEmpty()){
		QMessageBox::information(this,"ServoGui","The batch file name is empty!!!\n",QMessageBox::Ok);
		return;
	}
	batchFile.setFileName(ui.lineEditBatchFile->text());
	if (!batchFile.open(QIODevice::ReadOnly | QIODevice::Text)){
		QMessageBox::information(this,"ServoGui","Could not open file!!!\n",QMessageBox::Ok);
	}
	while (!batchFile.atEnd()) {
		QByteArray line = batchFile.readLine();
		/* Add an extra \n if the last line of the batch file does not ends with \n */
		if (!line.endsWith('\n')){
			line.append('\n');
		}
		/* Send the new position to the server */
		printf("Request To Server: %s\n",line.data());
		if (blocking_write_to_server(line.data(),strlen(line.data()))) /* Error */ return;
		state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
		printf("state: MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY\n");
		if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
		printf("Reply From Server: %s\n",data_buffer);
		/* Reply from server: release the lock */
		state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
		printf("state: MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND\n");
	}
}
void ServoGui::on_pushButtonBrowseBatchFile_clicked(void){
	 ui.lineEditBatchFile->setText(QFileDialog::getOpenFileName(this,"Batch File", ".", "Batch File (*.*)"));
}

void ServoGui::on_pushButtonWriteConfig_clicked(void)
{
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	if (ui.lineEditConfigFile->text().isEmpty()){
		QMessageBox::information(this,"ServoGui","The config file name is empty!!!\n",QMessageBox::Ok);
		return;
	}
	sprintf(data_buffer,"WRITE_CONFIG_FILE \"%s\"\n",ui.lineEditConfigFile->text().toAscii().data());
	/* Send the new position to the server */
	if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return;
	state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
	if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
	/* Reply from server: release the lock */
	state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
}
/*
 * This function get all the current values for each managed R/C servo by the server
 */
void ServoGui::on_pushButtonLoadValuesFromServer_clicked(void)
{
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	loadValuesFromServer();
}

void ServoGui::on_pushButtonQuit_clicked(void)
{
	printf("on_pushButtonQuit_clicked\n");
	this->parent->quit();
}
void ServoGui::update_position(int servo_id, int new_value)
{
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	sprintf(data_buffer,"SET_POSITION (%d , %d)\n",servo_id, new_value);
	/* Send the new position to the server */
	if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return;
	state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
	if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
	/* Reply from server: release the lock */
	state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
}
void ServoGui::update_offset(int servo_id, int new_value)
{
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	sprintf(data_buffer,"SET_OFFSET (%d , %d)\n",servo_id, new_value);
	/* Send the new offset to the server */
	if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return;
	state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
	if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
	/* Reply from server: release the lock */
	state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
}

void ServoGui::update_min(int servo_id, int new_value)
{
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	sprintf(data_buffer,"SET_MIN (%d , %d)\n",servo_id, new_value);
	/* Send the new min to the server */
	if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return;
	state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
	if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
	/* Reply from server: release the lock */
	state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;

}

void ServoGui::update_max(int servo_id, int new_value)
{
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	sprintf(data_buffer,"SET_MAX (%d , %d)\n",servo_id, new_value);
	/* Send the new max to the server */
	if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return;
	state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
	if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
	/* Reply from server: release the lock */
	state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
}

void ServoGui::update_enable(int servo_id, int new_value)
{
	if (new_value == 2) new_value=1;
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	if ((state != MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND) &&  (state != MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY)){
		/* The client is not connected */
		QMessageBox::information(this,"ServoGui","Client not connected!!!\n",QMessageBox::Ok);
		return;
	}
	sprintf(data_buffer,"SET_ENABLE (%d , %d)\n",servo_id, new_value);
	/* Send the new state to the server */
	if(blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return;
	state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
	if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
	/* Reply from server: release the lock */
	state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
}
void ServoGui::on_verticalSlider_0_valueChanged(int new_value)
{
	this->ui.pos_0->setValue(new_value);
}
void ServoGui::on_verticalSlider_1_valueChanged(int new_value)
{
	this->ui.pos_1->setValue(new_value);
//	this->update_position(1,new_value);
}
void ServoGui::on_verticalSlider_2_valueChanged(int new_value)
{
	this->ui.pos_2->setValue(new_value);
//	this->update_position(2,new_value);
}
void ServoGui::on_verticalSlider_3_valueChanged(int new_value)
{
	this->ui.pos_3->setValue(new_value);
//	this->update_position(3,new_value);
}
void ServoGui::on_verticalSlider_4_valueChanged(int new_value)
{
	this->ui.pos_4->setValue(new_value);
//	this->update_position(4,new_value);
}
void ServoGui::on_verticalSlider_5_valueChanged(int new_value)
{
	this->ui.pos_5->setValue(new_value);
//	this->update_position(5,new_value);
}
void ServoGui::on_verticalSlider_6_valueChanged(int new_value)
{
	this->ui.pos_6->setValue(new_value);
//	this->update_position(6,new_value);
}
void ServoGui::on_verticalSlider_7_valueChanged(int new_value)
{
	this->ui.pos_7->setValue(new_value);
//	this->update_position(7,new_value);
}
void ServoGui::on_verticalSlider_8_valueChanged(int new_value)
{
	this->ui.pos_8->setValue(new_value);
//	this->update_position(8,new_value);
}
void ServoGui::on_verticalSlider_9_valueChanged(int new_value)
{
	this->ui.pos_9->setValue(new_value);
//	this->update_position(9,new_value);
}
void ServoGui::on_verticalSlider_10_valueChanged(int new_value)
{
	this->ui.pos_10->setValue(new_value);
//	this->update_position(10,new_value);
}
void ServoGui::on_verticalSlider_11_valueChanged(int new_value)
{
	this->ui.pos_11->setValue(new_value);
//	this->update_position(11,new_value);
}
void ServoGui::on_verticalSlider_12_valueChanged(int new_value)
{
	this->ui.pos_12->setValue(new_value);
//	this->update_position(12,new_value);
}
void ServoGui::on_verticalSlider_13_valueChanged(int new_value)
{
	this->ui.pos_13->setValue(new_value);
//	this->update_position(13,new_value);
}
void ServoGui::on_verticalSlider_14_valueChanged(int new_value)
{
	this->ui.pos_14->setValue(new_value);
//	this->update_position(14,new_value);
}
void ServoGui::on_verticalSlider_15_valueChanged(int new_value)
{
	this->ui.pos_15->setValue(new_value);
//	this->update_position(15,new_value);
}
void ServoGui::on_verticalSlider_16_valueChanged(int new_value)
{
	this->ui.pos_16->setValue(new_value);
//	this->update_position(16,new_value);
}
void ServoGui::on_verticalSlider_17_valueChanged(int new_value)
{
	this->ui.pos_17->setValue(new_value);
//	this->update_position(17,new_value);
}
void ServoGui::on_verticalSlider_18_valueChanged(int new_value)
{
	this->ui.pos_18->setValue(new_value);
//	this->update_position(18,new_value);
}
void ServoGui::on_verticalSlider_19_valueChanged(int new_value)
{
	this->ui.pos_19->setValue(new_value);
//	this->update_position(19,new_value);
}
void ServoGui::on_verticalSlider_20_valueChanged(int new_value)
{
	this->ui.pos_20->setValue(new_value);
//	this->update_position(20,new_value);
}
void ServoGui::on_verticalSlider_21_valueChanged(int new_value)
{
	this->ui.pos_21->setValue(new_value);
//	this->update_position(21,new_value);
}
void ServoGui::on_verticalSlider_22_valueChanged(int new_value)
{
	this->ui.pos_22->setValue(new_value);
//	this->update_position(22,new_value);
}
void ServoGui::on_verticalSlider_23_valueChanged(int new_value)
{
	this->ui.pos_23->setValue(new_value);
//	this->update_position(23,new_value);
}

void ServoGui::on_pos_0_valueChanged(int new_value)
{
	this->ui.verticalSlider_0->setValue(new_value);
	this->update_position(0,new_value);
}
void ServoGui::on_pos_1_valueChanged(int new_value)
{
	this->ui.verticalSlider_1->setValue(new_value);
	this->update_position(1,new_value);
}
void ServoGui::on_pos_2_valueChanged(int new_value)
{
	this->ui.verticalSlider_2->setValue(new_value);
	this->update_position(2,new_value);
}
void ServoGui::on_pos_3_valueChanged(int new_value)
{
	this->ui.verticalSlider_3->setValue(new_value);
	this->update_position(3,new_value);
}
void ServoGui::on_pos_4_valueChanged(int new_value)
{
	this->ui.verticalSlider_4->setValue(new_value);
	this->update_position(4,new_value);
}
void ServoGui::on_pos_5_valueChanged(int new_value)
{
	this->ui.verticalSlider_5->setValue(new_value);
	this->update_position(5,new_value);
}
void ServoGui::on_pos_6_valueChanged(int new_value)
{
	this->ui.verticalSlider_6->setValue(new_value);
	this->update_position(6,new_value);
}
void ServoGui::on_pos_7_valueChanged(int new_value)
{
	this->ui.verticalSlider_7->setValue(new_value);
	this->update_position(7,new_value);
}
void ServoGui::on_pos_8_valueChanged(int new_value)
{
	this->ui.verticalSlider_8->setValue(new_value);
	this->update_position(8,new_value);
}
void ServoGui::on_pos_9_valueChanged(int new_value)
{
	this->ui.verticalSlider_9->setValue(new_value);
	this->update_position(9,new_value);
}
void ServoGui::on_pos_10_valueChanged(int new_value)
{
	this->ui.verticalSlider_10->setValue(new_value);
	this->update_position(10,new_value);
}
void ServoGui::on_pos_11_valueChanged(int new_value)
{
	this->ui.verticalSlider_11->setValue(new_value);
	this->update_position(11,new_value);
}
void ServoGui::on_pos_12_valueChanged(int new_value)
{
	this->ui.verticalSlider_12->setValue(new_value);
	this->update_position(12,new_value);
}
void ServoGui::on_pos_13_valueChanged(int new_value)
{
	this->ui.verticalSlider_13->setValue(new_value);
	this->update_position(13,new_value);
}
void ServoGui::on_pos_14_valueChanged(int new_value)
{
	this->ui.verticalSlider_14->setValue(new_value);
	this->update_position(14,new_value);
}
void ServoGui::on_pos_15_valueChanged(int new_value)
{
	this->ui.verticalSlider_15->setValue(new_value);
	this->update_position(15,new_value);
}
void ServoGui::on_pos_16_valueChanged(int new_value)
{
	this->ui.verticalSlider_16->setValue(new_value);
	this->update_position(16,new_value);
}
void ServoGui::on_pos_17_valueChanged(int new_value)
{
	this->ui.verticalSlider_17->setValue(new_value);
	this->update_position(17,new_value);
}
void ServoGui::on_pos_18_valueChanged(int new_value)
{
	this->ui.verticalSlider_18->setValue(new_value);
	this->update_position(18,new_value);
}
void ServoGui::on_pos_19_valueChanged(int new_value)
{
	this->ui.verticalSlider_19->setValue(new_value);
	this->update_position(19,new_value);
}
void ServoGui::on_pos_20_valueChanged(int new_value)
{
	this->ui.verticalSlider_20->setValue(new_value);
	this->update_position(20,new_value);
}
void ServoGui::on_pos_21_valueChanged(int new_value)
{
	this->ui.verticalSlider_21->setValue(new_value);
	this->update_position(21,new_value);
}
void ServoGui::on_pos_22_valueChanged(int new_value)
{
	this->ui.verticalSlider_22->setValue(new_value);
	this->update_position(22,new_value);
}
void ServoGui::on_pos_23_valueChanged(int new_value)
{
	this->ui.verticalSlider_23->setValue(new_value);
	this->update_position(23,new_value);
}
void ServoGui::on_checkBox_0_stateChanged(int new_value)
{
	this->update_enable(0,new_value);
}
void ServoGui::on_checkBox_1_stateChanged(int new_value)
{
	this->update_enable(1,new_value);
}
void ServoGui::on_checkBox_2_stateChanged(int new_value)
{
	this->update_enable(2,new_value);
}
void ServoGui::on_checkBox_3_stateChanged(int new_value)
{
	this->update_enable(3,new_value);
}
void ServoGui::on_checkBox_4_stateChanged(int new_value)
{
	this->update_enable(4,new_value);
}
void ServoGui::on_checkBox_5_stateChanged(int new_value)
{
	this->update_enable(5,new_value);
}
void ServoGui::on_checkBox_6_stateChanged(int new_value)
{
	this->update_enable(6,new_value);
}
void ServoGui::on_checkBox_7_stateChanged(int new_value)
{
	this->update_enable(7,new_value);
}
void ServoGui::on_checkBox_8_stateChanged(int new_value)
{
	this->update_enable(8,new_value);
}
void ServoGui::on_checkBox_9_stateChanged(int new_value)
{
	this->update_enable(9,new_value);
}
void ServoGui::on_checkBox_10_stateChanged(int new_value)
{
	this->update_enable(10,new_value);
}
void ServoGui::on_checkBox_11_stateChanged(int new_value)
{
	this->update_enable(11,new_value);
}
void ServoGui::on_checkBox_12_stateChanged(int new_value)
{
	this->update_enable(12,new_value);
}
void ServoGui::on_checkBox_13_stateChanged(int new_value)
{
	this->update_enable(13,new_value);
}
void ServoGui::on_checkBox_14_stateChanged(int new_value)
{
	this->update_enable(14,new_value);
}
void ServoGui::on_checkBox_15_stateChanged(int new_value)
{
	this->update_enable(15,new_value);
}
void ServoGui::on_checkBox_16_stateChanged(int new_value)
{
	this->update_enable(16,new_value);
}
void ServoGui::on_checkBox_17_stateChanged(int new_value)
{
	this->update_enable(17,new_value);
}
void ServoGui::on_checkBox_18_stateChanged(int new_value)
{
	this->update_enable(18,new_value);
}
void ServoGui::on_checkBox_19_stateChanged(int new_value)
{
	this->update_enable(19,new_value);
}
void ServoGui::on_checkBox_20_stateChanged(int new_value)
{
	this->update_enable(21,new_value);
}
void ServoGui::on_checkBox_21_stateChanged(int new_value)
{
	this->update_enable(21,new_value);
}
void ServoGui::on_checkBox_22_stateChanged(int new_value)
{
	this->update_enable(22,new_value);
}
void ServoGui::on_checkBox_23_stateChanged(int new_value)
{
	this->update_enable(23,new_value);
}
void ServoGui::on_off_0_valueChanged(int new_value)
{
	this->update_offset(0,new_value);
}
void ServoGui::on_off_1_valueChanged(int new_value)
{
	this->update_offset(1,new_value);
}
void ServoGui::on_off_2_valueChanged(int new_value)
{
	this->update_offset(2,new_value);
}
void ServoGui::on_off_3_valueChanged(int new_value)
{
	this->update_offset(3,new_value);
}
void ServoGui::on_off_4_valueChanged(int new_value)
{
	this->update_offset(4,new_value);
}
void ServoGui::on_off_5_valueChanged(int new_value)
{
	this->update_offset(5,new_value);
}
void ServoGui::on_off_6_valueChanged(int new_value)
{
	this->update_offset(6,new_value);
}
void ServoGui::on_off_7_valueChanged(int new_value)
{
	this->update_offset(7,new_value);
}
void ServoGui::on_off_8_valueChanged(int new_value)
{
	this->update_offset(8,new_value);
}
void ServoGui::on_off_9_valueChanged(int new_value)
{
	this->update_offset(9,new_value);
}
void ServoGui::on_off_10_valueChanged(int new_value)
{
	this->update_offset(10,new_value);
}
void ServoGui::on_off_11_valueChanged(int new_value)
{
	this->update_offset(11,new_value);
}
void ServoGui::on_off_12_valueChanged(int new_value)
{
	this->update_offset(12,new_value);
}
void ServoGui::on_off_13_valueChanged(int new_value)
{
	this->update_offset(13,new_value);
}
void ServoGui::on_off_14_valueChanged(int new_value)
{
	this->update_offset(14,new_value);
}
void ServoGui::on_off_15_valueChanged(int new_value)
{
	this->update_offset(15,new_value);
}
void ServoGui::on_off_16_valueChanged(int new_value)
{
	this->update_offset(16,new_value);
}
void ServoGui::on_off_17_valueChanged(int new_value)
{
	this->update_offset(17,new_value);
}
void ServoGui::on_off_18_valueChanged(int new_value)
{
	this->update_offset(18,new_value);
}
void ServoGui::on_off_19_valueChanged(int new_value)
{
	this->update_offset(19,new_value);
}
void ServoGui::on_off_20_valueChanged(int new_value)
{
	this->update_offset(20,new_value);
}
void ServoGui::on_off_21_valueChanged(int new_value)
{
	this->update_offset(21,new_value);
}
void ServoGui::on_off_22_valueChanged(int new_value)
{
	this->update_offset(22,new_value);
}
void ServoGui::on_off_23_valueChanged(int new_value)
{
	this->update_offset(23,new_value);
}
void ServoGui::on_min_0_valueChanged(int new_value)
{
	this->update_min(0,new_value);
}
void ServoGui::on_min_1_valueChanged(int new_value)
{
	this->update_min(1,new_value);
}
void ServoGui::on_min_2_valueChanged(int new_value)
{
	this->update_min(2,new_value);
}
void ServoGui::on_min_3_valueChanged(int new_value)
{
	this->update_min(3,new_value);
}
void ServoGui::on_min_4_valueChanged(int new_value)
{
	this->update_min(4,new_value);
}
void ServoGui::on_min_5_valueChanged(int new_value)
{
	this->update_min(5,new_value);
}
void ServoGui::on_min_6_valueChanged(int new_value)
{
	this->update_min(6,new_value);
}
void ServoGui::on_min_7_valueChanged(int new_value)
{
	this->update_min(7,new_value);
}
void ServoGui::on_min_8_valueChanged(int new_value)
{
	this->update_min(8,new_value);
}
void ServoGui::on_min_9_valueChanged(int new_value)
{
	this->update_min(9,new_value);
}
void ServoGui::on_min_10_valueChanged(int new_value)
{
	this->update_min(10,new_value);
}
void ServoGui::on_min_11_valueChanged(int new_value)
{
	this->update_min(11,new_value);
}
void ServoGui::on_min_12_valueChanged(int new_value)
{
	this->update_min(12,new_value);
}
void ServoGui::on_min_13_valueChanged(int new_value)
{
	this->update_min(13,new_value);
}
void ServoGui::on_min_14_valueChanged(int new_value)
{
	this->update_min(14,new_value);
}
void ServoGui::on_min_15_valueChanged(int new_value)
{
	this->update_min(15,new_value);
}
void ServoGui::on_min_16_valueChanged(int new_value)
{
	this->update_min(16,new_value);
}
void ServoGui::on_min_17_valueChanged(int new_value)
{
	this->update_min(17,new_value);
}
void ServoGui::on_min_18_valueChanged(int new_value)
{
	this->update_min(18,new_value);
}
void ServoGui::on_min_19_valueChanged(int new_value)
{
	this->update_min(19,new_value);
}
void ServoGui::on_min_20_valueChanged(int new_value)
{
	this->update_min(20,new_value);
}
void ServoGui::on_min_21_valueChanged(int new_value)
{
	this->update_min(21,new_value);
}
void ServoGui::on_min_22_valueChanged(int new_value)
{
	this->update_min(22,new_value);
}
void ServoGui::on_min_23_valueChanged(int new_value)
{
	this->update_min(23,new_value);
}

void ServoGui::on_max_0_valueChanged(int new_value)
{
	this->update_max(0,new_value);
}
void ServoGui::on_max_1_valueChanged(int new_value)
{
	this->update_max(1,new_value);
}
void ServoGui::on_max_2_valueChanged(int new_value)
{
	this->update_max(2,new_value);
}
void ServoGui::on_max_3_valueChanged(int new_value)
{
	this->update_max(3,new_value);
}
void ServoGui::on_max_4_valueChanged(int new_value)
{
	this->update_max(4,new_value);
}
void ServoGui::on_max_5_valueChanged(int new_value)
{
	this->update_max(5,new_value);
}
void ServoGui::on_max_6_valueChanged(int new_value)
{
	this->update_max(6,new_value);
}
void ServoGui::on_max_7_valueChanged(int new_value)
{
	this->update_max(7,new_value);
}
void ServoGui::on_max_8_valueChanged(int new_value)
{
	this->update_max(8,new_value);
}
void ServoGui::on_max_9_valueChanged(int new_value)
{
	this->update_max(9,new_value);
}
void ServoGui::on_max_10_valueChanged(int new_value)
{
	this->update_max(10,new_value);
}
void ServoGui::on_max_11_valueChanged(int new_value)
{
	this->update_max(11,new_value);
}
void ServoGui::on_max_12_valueChanged(int new_value)
{
	this->update_max(12,new_value);
}
void ServoGui::on_max_13_valueChanged(int new_value)
{
	this->update_max(13,new_value);
}
void ServoGui::on_max_14_valueChanged(int new_value)
{
	this->update_max(14,new_value);
}
void ServoGui::on_max_15_valueChanged(int new_value)
{
	this->update_max(15,new_value);
}
void ServoGui::on_max_16_valueChanged(int new_value)
{
	this->update_max(16,new_value);
}
void ServoGui::on_max_17_valueChanged(int new_value)
{
	this->update_max(17,new_value);
}
void ServoGui::on_max_18_valueChanged(int new_value)
{
	this->update_max(18,new_value);
}
void ServoGui::on_max_19_valueChanged(int new_value)
{
	this->update_max(19,new_value);
}
void ServoGui::on_max_20_valueChanged(int new_value)
{
	this->update_max(20,new_value);
}
void ServoGui::on_max_21_valueChanged(int new_value)
{
	this->update_max(21,new_value);
}
void ServoGui::on_max_22_valueChanged(int new_value)
{
	this->update_max(22,new_value);
}
void ServoGui::on_max_23_valueChanged(int new_value)
{
	this->update_max(23,new_value);
}

void ServoGui::on_pushButton_connect_clicked(void)
{
	if (state == MOTION_CLIENT_STATE_NOT_CONNECTED){
		clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
		if (ui.lineEditHost->text().isEmpty()){
			QMessageBox::information(this,"ServoGui","The host name is empty!!!\n",QMessageBox::Ok);
			return;
		}
		socket->disconnectFromHost();
		/* Connection to the server */
		socket->connectToHost(ui.lineEditHost->text(),MOTION_SERVER_TCP_PORT);
		if (!socket->waitForConnected(5000)){
			QMessageBox::information(this,"ServoGui","Failed to connect to host!!!\n",QMessageBox::Ok);
			return;
		}
		state = MOTION_CLIENT_STATE_CONNECTED_NO_SIGNED;
		printf("state: MOTION_CLIENT_STATE_CONNECTED_NO_SIGNED\n");
		printf("Connexion Ok: %s\n",ui.lineEditHost->text().toAscii().data());
		/* The client is waiting the Motion Server signature */
		if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return;
		printf("Reply From Server: %s\n",data_buffer);
		/* Check the connected server is a real Motion Server... */
		if (strcmp(data_buffer,MOTION_SERVER_SIGNATURE)!=0){
			QMessageBox::information(this,"ServoGui","The remote server in not a Motion Server!!!\n",QMessageBox::Ok);
			disconnection_from_server();
			return;
		} else {
			state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
			printf("state: MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND\n");
			this->ui.label_connected->setText("Connected");
			this->ui.pushButton_connect->setText("Disconnect");
			loadValuesFromServer();
		}
	} else {
		disconnection_from_server();
	}
}

void ServoGui::clean_buffer(char* buffer,int size){
	int i;
	for(i=0;i<size;i++) buffer[i]=0;
}
int ServoGui::blocking_read_from_server(char * reply, int size){
	/* This method wait until the server replies to a client request
	 * in the limit of MOTION_CLIENT_TIMEOUT
	 */
	char read_buffer=0;
	int i=0;
	int ret;
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
	/* Waiting for reply from the Motion Server */
	if(socket->waitForReadyRead(MOTION_CLIENT_TIMEOUT)){
		/* Data available reading until end of line*/
		while(read_buffer != '\n' && i<size){
			ret=socket->read(&read_buffer,1);
			/* End of available data */
			if (ret == 0) break;
			/* Socket error */
			if (ret==-1){
				QMessageBox::information(this,"ServoGui","Socket Read Error: CLosing the connection!!!!!!\n",QMessageBox::Ok);
				disconnection_from_server();
				return 1;
			}
			reply[i]=read_buffer;
			i++;
		}
	} else {
		/* Time Out or socket error -> disconnection */
		QMessageBox::information(this,"ServoGui","Socket Time Out or Read Error : CLosing the connection!!!\n",QMessageBox::Ok);
		disconnection_from_server();
		return 1;
	}
	/* Add Final 0*/
	data_buffer[i]=0;
	return 0;
}

int ServoGui::blocking_write_to_server(char * request,int size){
	/* This method send request to the server and wait
	 * that data are written  in the limit of MOTION_CLIENT_TIMEOUT
	 */
	if (socket->write(request,size)==-1){
		/*Socket Error */
		QMessageBox::information(this,"ServoGui","Socket Write Error: CLosing the connection!!!!!!\n",QMessageBox::Ok);
		disconnection_from_server();
		return 1;
	}
	if (socket->waitForBytesWritten (MOTION_CLIENT_TIMEOUT)){
		return 0;
	} else {
		/* Time Out or socket error -> disconnection */
		QMessageBox::information(this,"ServoGui","Socket Time Out or Write Error : CLosing the connection!!!\n",QMessageBox::Ok);
		disconnection_from_server();
		return 1;
	}
}

int ServoGui::disconnection_from_server(void){
	socket->disconnectFromHost();
	this->ui.label_connected->setText("Not Connected");
	this->ui.pushButton_connect->setText("Connect");
	state=MOTION_CLIENT_STATE_NOT_CONNECTED;
	printf("state: MOTION_CLIENT_STATE_NOT_CONNECTED\n");
	return 0;
}
int ServoGui::loadValuesFromServer(void){
	int i;
	clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);

	/* Read the position for each R/C servo et put this value on slider and spinbox */
	for(i=0;i<MOTION_CLIENT_NBR_OF_MANAGED_SERVOS;i++){
		clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
		sprintf(data_buffer,"GET_POSITION (%d)\n",i);
		/* Send position request to the server */
		if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return -1;
		state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
		if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return -1;
		/* Reply from server: release the lock */
		state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
		/* Update slider and spinbox */
		verticalSliders[i]->setValue(atoi(data_buffer));
	}
	/* Read the offset for each R/C servo et put this value on spinbox */
	for(i=0;i<MOTION_CLIENT_NBR_OF_MANAGED_SERVOS;i++){
		clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
		sprintf(data_buffer,"GET_OFFSET (%d)\n",i);
		/* Send position request to the server */
		if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return -1;
		state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
		if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return -1;
		/* Reply from server: release the lock */
		state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
		/* Update spinbox */
		offsetSpinboxes[i]->setValue(atoi(data_buffer));
	}
	/* Read the Min for each R/C servo et put this value on spinbox */
	for(i=0;i<MOTION_CLIENT_NBR_OF_MANAGED_SERVOS;i++){
		clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
		sprintf(data_buffer,"GET_MIN (%d)\n",i);
		/* Send position request to the server */
		if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return -1;
		state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
		if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return -1;
		/* Reply from server: release the lock */
		state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
		/* Update spinbox */
		minSpinboxes[i]->setValue(atoi(data_buffer));
	}
	/* Read the Max for each R/C servo et put this value on spinbox */
	for(i=0;i<MOTION_CLIENT_NBR_OF_MANAGED_SERVOS;i++){
		clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
		sprintf(data_buffer,"GET_MAX (%d)\n",i);
		/* Send position request to the server */
		if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return -1;
		state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
		if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return -1;
		/* Reply from server: release the lock */
		state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
		/* Update spinbox */
		maxSpinboxes[i]->setValue(atoi(data_buffer));
	}
	/* Read the Enable status for each R/C servo et put this value on checkbox */
	for(i=0;i<MOTION_CLIENT_NBR_OF_MANAGED_SERVOS;i++){
		clean_buffer(data_buffer,MOTION_CLIENT_BUFFER_SIZE);
		sprintf(data_buffer,"GET_ENABLE (%d)\n",i);
		/* Send position request to the server */
		if (blocking_write_to_server(data_buffer,strlen(data_buffer))) /* Error */ return -1;
		state=MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY;
		if(blocking_read_from_server(data_buffer,MOTION_CLIENT_BUFFER_SIZE)) /* Error */ return -1;
		/* Reply from server: release the lock */
		state = MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND;
		/* Update checkbox */
		if (atoi(data_buffer)==0){
			enableCheckboxes[i]->setCheckState(Qt::Unchecked);
		}
		if (atoi(data_buffer)==1){
			enableCheckboxes[i]->setCheckState(Qt::Checked);
		}
	}
	return 0;
}
