/*
 *    servogui.h
 *
 *    Copyright (C) 2008-2011 Yvan Roch <yvan.roch@gmail.com>
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SERVOGUI_H
#define SERVOGUI_H

#include <QtGui/QDialog>
#include <QtNetwork/QTcpSocket>
#include <QMessageBox>
#include <QFile>
#include <QFileDialog>
#include "ui_servogui.h"

#define MOTION_SERVER_TCP_PORT 1972
#define MOTION_SERVER_SIGNATURE "MOTION SERVER OK"
#define MOTION_CLIENT_TIMEOUT 30000		/* Time Out for read and */
#define MOTION_CLIENT_STATE_NOT_CONNECTED 0			/*Socket not connected*/
#define MOTION_CLIENT_STATE_CONNECTED_NO_SIGNED	 1	/*Socket connected, Motion Server signature is not received or processed by the client*/
#define MOTION_CLIENT_STATE_CONNECTED_READY_TO_SEND 2	/*Socket connected, Motion Server signature is OK, client ready to send command*/
#define MOTION_CLIENT_STATE_CONNECTED_WAIT_FOR_REPLY 4	/*Socket connected, Motion Server signature is OK, client waits reply from server*/
#define MOTION_CLIENT_BUFFER_SIZE 1024
#define MOTION_CLIENT_NBR_OF_MANAGED_SERVOS 24
class ServoGui : public QDialog
{
    Q_OBJECT

public:
    ServoGui(QWidget *parent = 0);
    ServoGui(QApplication *QApplication);
    ~ServoGui();

private slots:
    void on_pushButtonWriteConfig_clicked(void);
    void on_pushButtonSendBatchFile_clicked(void);
    void on_pushButtonBrowseBatchFile_clicked(void);
    void on_pushButtonLoadValuesFromServer_clicked(void);
    void on_pushButtonQuit_clicked(void);
    void on_verticalSlider_0_valueChanged(int);
    void on_verticalSlider_1_valueChanged(int);
    void on_verticalSlider_2_valueChanged(int);
    void on_verticalSlider_3_valueChanged(int);
    void on_verticalSlider_4_valueChanged(int);
    void on_verticalSlider_5_valueChanged(int);
    void on_verticalSlider_6_valueChanged(int);
    void on_verticalSlider_7_valueChanged(int);
    void on_verticalSlider_8_valueChanged(int);
    void on_verticalSlider_9_valueChanged(int);
    void on_verticalSlider_10_valueChanged(int);
    void on_verticalSlider_11_valueChanged(int);
    void on_verticalSlider_12_valueChanged(int);
    void on_verticalSlider_13_valueChanged(int);
    void on_verticalSlider_14_valueChanged(int);
    void on_verticalSlider_15_valueChanged(int);
    void on_verticalSlider_16_valueChanged(int);
    void on_verticalSlider_17_valueChanged(int);
    void on_verticalSlider_18_valueChanged(int);
    void on_verticalSlider_19_valueChanged(int);
    void on_verticalSlider_20_valueChanged(int);
    void on_verticalSlider_21_valueChanged(int);
    void on_verticalSlider_22_valueChanged(int);
    void on_verticalSlider_23_valueChanged(int);
    void on_pos_0_valueChanged(int);
    void on_pos_1_valueChanged(int);
    void on_pos_2_valueChanged(int);
    void on_pos_3_valueChanged(int);
    void on_pos_4_valueChanged(int);
    void on_pos_5_valueChanged(int);
    void on_pos_6_valueChanged(int);
    void on_pos_7_valueChanged(int);
    void on_pos_8_valueChanged(int);
    void on_pos_9_valueChanged(int);
    void on_pos_10_valueChanged(int);
    void on_pos_11_valueChanged(int);
    void on_pos_12_valueChanged(int);
    void on_pos_13_valueChanged(int);
    void on_pos_14_valueChanged(int);
    void on_pos_15_valueChanged(int);
    void on_pos_16_valueChanged(int);
    void on_pos_17_valueChanged(int);
    void on_pos_18_valueChanged(int);
    void on_pos_19_valueChanged(int);
    void on_pos_20_valueChanged(int);
    void on_pos_21_valueChanged(int);
    void on_pos_22_valueChanged(int);
    void on_pos_23_valueChanged(int);
    void on_checkBox_0_stateChanged(int);
    void on_checkBox_1_stateChanged(int);
    void on_checkBox_2_stateChanged(int);
    void on_checkBox_3_stateChanged(int);
    void on_checkBox_4_stateChanged(int);
    void on_checkBox_5_stateChanged(int);
    void on_checkBox_6_stateChanged(int);
    void on_checkBox_7_stateChanged(int);
    void on_checkBox_8_stateChanged(int);
    void on_checkBox_9_stateChanged(int);
    void on_checkBox_10_stateChanged(int);
    void on_checkBox_11_stateChanged(int);
    void on_checkBox_12_stateChanged(int);
    void on_checkBox_13_stateChanged(int);
    void on_checkBox_14_stateChanged(int);
    void on_checkBox_15_stateChanged(int);
    void on_checkBox_16_stateChanged(int);
    void on_checkBox_17_stateChanged(int);
    void on_checkBox_18_stateChanged(int);
    void on_checkBox_19_stateChanged(int);
    void on_checkBox_20_stateChanged(int);
    void on_checkBox_21_stateChanged(int);
    void on_checkBox_22_stateChanged(int);
    void on_checkBox_23_stateChanged(int);
    void on_pushButton_connect_clicked(void);
    void on_off_0_valueChanged(int);
    void on_off_1_valueChanged(int);
    void on_off_2_valueChanged(int);
    void on_off_3_valueChanged(int);
    void on_off_4_valueChanged(int);
    void on_off_5_valueChanged(int);
    void on_off_6_valueChanged(int);
    void on_off_7_valueChanged(int);
    void on_off_8_valueChanged(int);
    void on_off_9_valueChanged(int);
    void on_off_10_valueChanged(int);
    void on_off_11_valueChanged(int);
    void on_off_12_valueChanged(int);
    void on_off_13_valueChanged(int);
    void on_off_14_valueChanged(int);
    void on_off_15_valueChanged(int);
    void on_off_16_valueChanged(int);
    void on_off_17_valueChanged(int);
    void on_off_18_valueChanged(int);
    void on_off_19_valueChanged(int);
    void on_off_20_valueChanged(int);
    void on_off_21_valueChanged(int);
    void on_off_22_valueChanged(int);
    void on_off_23_valueChanged(int);
    void on_min_0_valueChanged(int);
    void on_min_1_valueChanged(int);
    void on_min_2_valueChanged(int);
    void on_min_3_valueChanged(int);
    void on_min_4_valueChanged(int);
    void on_min_5_valueChanged(int);
    void on_min_6_valueChanged(int);
    void on_min_7_valueChanged(int);
    void on_min_8_valueChanged(int);
    void on_min_9_valueChanged(int);
    void on_min_10_valueChanged(int);
    void on_min_11_valueChanged(int);
    void on_min_12_valueChanged(int);
    void on_min_13_valueChanged(int);
    void on_min_14_valueChanged(int);
    void on_min_15_valueChanged(int);
    void on_min_16_valueChanged(int);
    void on_min_17_valueChanged(int);
    void on_min_18_valueChanged(int);
    void on_min_19_valueChanged(int);
    void on_min_20_valueChanged(int);
    void on_min_21_valueChanged(int);
    void on_min_22_valueChanged(int);
    void on_min_23_valueChanged(int);
    void on_max_0_valueChanged(int);
    void on_max_1_valueChanged(int);
    void on_max_2_valueChanged(int);
    void on_max_3_valueChanged(int);
    void on_max_4_valueChanged(int);
    void on_max_5_valueChanged(int);
    void on_max_6_valueChanged(int);
    void on_max_7_valueChanged(int);
    void on_max_8_valueChanged(int);
    void on_max_9_valueChanged(int);
    void on_max_10_valueChanged(int);
    void on_max_11_valueChanged(int);
    void on_max_12_valueChanged(int);
    void on_max_13_valueChanged(int);
    void on_max_14_valueChanged(int);
    void on_max_15_valueChanged(int);
    void on_max_16_valueChanged(int);
    void on_max_17_valueChanged(int);
    void on_max_18_valueChanged(int);
    void on_max_19_valueChanged(int);
    void on_max_20_valueChanged(int);
    void on_max_21_valueChanged(int);
    void on_max_22_valueChanged(int);
    void on_max_23_valueChanged(int);

private:
	Ui::ServoGuiClass ui;
	QApplication *parent;
	QTcpSocket *socket;
	void clean_buffer(char* ,int);
	void update_position(int,int);
	void update_enable(int,int);
	void update_offset(int,int);
	void update_min(int,int);
	void update_max(int,int);
	int blocking_write_to_server(char *,int);
	int blocking_read_from_server(char *,int);
	int disconnection_from_server(void);
	int loadValuesFromServer(void);
	char data_buffer[MOTION_CLIENT_BUFFER_SIZE];
	/* Array of pointers to verticalSliders */
	QSlider* verticalSliders[MOTION_CLIENT_NBR_OF_MANAGED_SERVOS];
	/* Array of pointers to offset spinboxes  */
	QSpinBox* offsetSpinboxes[MOTION_CLIENT_NBR_OF_MANAGED_SERVOS];
	/* Array of pointers to min spinboxes  */
	QSpinBox* minSpinboxes[MOTION_CLIENT_NBR_OF_MANAGED_SERVOS];
	/* Array of pointers to max spinboxes  */
	QSpinBox* maxSpinboxes[MOTION_CLIENT_NBR_OF_MANAGED_SERVOS];
	/* Array of pointers to max spinboxes  */
	QCheckBox* enableCheckboxes[MOTION_CLIENT_NBR_OF_MANAGED_SERVOS];

	/* Client state, i.e. MOTION_CLIENT_STATE_* */
	int state;
};

#endif // SERVOGUI_H
